import "core-js/modules/es.array.concat";
import "core-js/modules/es.array.for-each";
import "core-js/modules/es.array.map";
import "core-js/modules/es.function.name";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.get-prototype-of";
import "core-js/modules/es.object.to-string";
import "core-js/modules/es.reflect.construct";
import "core-js/modules/es.regexp.to-string";
import "core-js/modules/web.dom-collections.for-each";

function _createSuper(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

import React, { PureComponent } from "react";
import LazyImage from "./LazyImage";
import classname from 'classnames';

var LazyLoad = /*#__PURE__*/function (_PureComponent) {
  _inheritsLoose(LazyLoad, _PureComponent);

  var _super = _createSuper(LazyLoad);

  function LazyLoad() {
    var _temp, _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return (_temp = _this = _PureComponent.call.apply(_PureComponent, [this].concat(args)) || this, _this.containerDiv = React.createRef(), _this.imgRefs = [], _this.observer = null, _this.intersectionObserver = function () {
      if (!window.hasOwnProperty('IntersectionObserver')) {
        _this.imgRefs.forEach(function (img) {
          img.src = img.dataset.src || '';
        });

        return;
      } //初始化监听方法


      _this.observer = new IntersectionObserver(function (entries) {
        entries.forEach(function (item) {
          if (item.isIntersecting) {
            var img = item.target;
            setTimeout(function () {
              if (img.dataset.src) {
                img.src = img.dataset.src;
              }
            }, _this.props.delay);

            _this.observer.unobserve(img);
          }
        });
      }, {
        root: _this.props.rootElement || _this.containerDiv.current
      });

      _this.imgRefs.forEach(function (c) {
        _this.observer.observe(c);
      });
    }, _this.loopChildren = function (children) {
      return React.Children.map(children, function (child) {
        /**
         * 普通img标签
         */
        if (child && child.type === 'img' && child.props && child.props['data-lazy'] === 'true') {
          return React.cloneElement(child, {
            ref: function ref(e) {
              if (e) {
                _this.imgRefs.push(e);
              }
            }
          });
        }
        /**
         * LvLazyImage组件
         */
        else if (child && typeof child.type === 'function' && child.type.name === LazyImage.name) {
            return React.cloneElement(child, {
              ref: function ref(e) {
                if (e && e.imageRef && e.imageRef.current) {
                  _this.imgRefs.push(e.imageRef.current);
                }
              }
            });
          } else if (child && child.props && child.props.children) {
            return React.cloneElement(child, {}, _this.loopChildren(child.props.children));
          } else {
            return child;
          }
      });
    }, _temp) || _assertThisInitialized(_this);
  }

  var _proto = LazyLoad.prototype;

  _proto.componentDidMount = function componentDidMount() {
    this.intersectionObserver();
  };

  _proto.componentDidUpdate = function componentDidUpdate(prevProps, prevState, snapshot) {
    if (this.props.data !== prevProps.data) {
      this.intersectionObserver();
    }
  }
  /**
   * 组件卸载时释放资源
   */
  ;

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.observer = null;
    this.imgRefs = [];
  }
  /**
   * 使用IntersectionObserver API监听图片显示
   * @constructor
   */
  ;

  _proto.render = function render() {
    var className = classname('lyc-lazyload', this.props.className);
    this.imgRefs = [];
    var divProps = Object.assign({}, this.props);
    delete divProps.rootElement;
    delete divProps.delay;
    delete divProps.data;
    return /*#__PURE__*/React.createElement("div", Object.assign({
      className: className
    }, divProps, {
      ref: this.containerDiv
    }), this.loopChildren(this.props.children));
  };

  return LazyLoad;
}(PureComponent);

LazyLoad.Image = LazyImage;
LazyLoad.displayName = '延迟加载组件';
LazyLoad.defaultProps = {
  delay: 200
};
export { LazyLoad as default };