import "core-js/modules/es.symbol";
import "core-js/modules/es.symbol.description";
import "core-js/modules/es.symbol.iterator";
import "core-js/modules/es.array.concat";
import "core-js/modules/es.array.for-each";
import "core-js/modules/es.array.from";
import "core-js/modules/es.array.iterator";
import "core-js/modules/es.array.slice";
import "core-js/modules/es.function.name";
import "core-js/modules/es.object.to-string";
import "core-js/modules/es.regexp.to-string";
import "core-js/modules/es.string.iterator";
import "core-js/modules/web.dom-collections.for-each";
import "core-js/modules/web.dom-collections.iterator";

function _createForOfIteratorHelperLoose(o) { var i = 0; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (o = _unsupportedIterableToArray(o))) return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } i = o[Symbol.iterator](); return i.next.bind(i); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(n); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

/**
 * 按条件树结构中某一个item的层级关系
 * @param array
 * @param filter
 * @param childrenKey
 */
export var $getItemTree = function $getItemTree(array, filter, childrenKey) {
  if (childrenKey === void 0) {
    childrenKey = 'children';
  }

  var list = [];
  var isFind = false;
  array.forEach(function (c) {
    //@ts-ignore
    c.isTop = true;
  });

  var loop = function loop(data) {
    if (isFind) {
      return false;
    }

    for (var _iterator = _createForOfIteratorHelperLoose(data), _step; !(_step = _iterator()).done;) {
      var m = _step.value;

      if (isFind) {
        break;
      } // 如果重新查找了一个顶级菜单，清空掉list
      // @ts-ignore


      if (m.isTop) {
        list = [];
      } // @ts-ignore


      var _children = m[childrenKey] || [];

      if (filter(m)) {
        // 找到了对应的末级了，退出递归
        // @ts-ignore
        list.push(m);
        isFind = true;
        break;
      } else if (_children && _children.length > 0) {
        // 还有子集，继续递归
        list.push(m);
        loop(_children);
      } else {// 没有子集了，也没有找到对应的末级，继续循环
      }
    }
  };

  loop(array);
  return list;
};
/**
 * 获取树结构中符合filter的item
 * @param datasource
 * @param filter
 * @param childKey
 */

export var loopDataTree = function loopDataTree(datasource, filter, childKey) {
  if (childKey === void 0) {
    childKey = 'children';
  }

  var result = [];

  for (var i = 0; i < datasource.length; i++) {
    var _item = datasource[i]; // @ts-ignore

    var _children = _item[childKey] || [];

    if (filter(_item)) {
      result.push(_item);
      break;
    } else if (_children.length > 0) {
      result = result.concat(loopDataTree(_children, filter, childKey));
    }
  }

  return result;
};