import React, { PureComponent } from "react";
import LazyImage from "./LazyImage";
export interface ILazyLoadProps extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLDivElement>, HTMLDivElement> {
    rootElement?: Element;
    delay?: number;
    className?: string;
    data: any;
}
export default class LazyLoad extends PureComponent<ILazyLoadProps> {
    static Image: typeof LazyImage;
    static displayName: string;
    static defaultProps: {
        delay: number;
    };
    private containerDiv;
    private imgRefs;
    private observer;
    componentDidMount(): void;
    componentDidUpdate(prevProps: Readonly<ILazyLoadProps>, prevState: Readonly<any>, snapshot?: any): void;
    /**
     * 组件卸载时释放资源
     */
    componentWillUnmount(): void;
    /**
     * 使用IntersectionObserver API监听图片显示
     * @constructor
     */
    intersectionObserver: () => void;
    loopChildren: (children: React.ReactNode) => React.ReactNode;
    render(): React.ReactNode;
}
