"use strict";

require("core-js/modules/es.symbol");

require("core-js/modules/es.symbol.description");

require("core-js/modules/es.symbol.iterator");

require("core-js/modules/es.array.concat");

require("core-js/modules/es.array.for-each");

require("core-js/modules/es.array.from");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.array.slice");

require("core-js/modules/es.function.name");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.regexp.to-string");

require("core-js/modules/es.string.iterator");

require("core-js/modules/web.dom-collections.for-each");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.loopDataTree = exports.$getItemTree = void 0;

function _createForOfIteratorHelper(o) { if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (o = _unsupportedIterableToArray(o))) { var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var it, normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(n); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

/**
 * 按条件树结构中某一个item的层级关系
 * @param array
 * @param filter
 * @param childrenKey
 */
var $getItemTree = function $getItemTree(array, filter) {
  var childrenKey = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'children';
  var list = [];
  var isFind = false;
  array.forEach(function (c) {
    //@ts-ignore
    c.isTop = true;
  });

  var loop = function loop(data) {
    if (isFind) {
      return false;
    }

    var _iterator = _createForOfIteratorHelper(data),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var m = _step.value;

        if (isFind) {
          break;
        } // 如果重新查找了一个顶级菜单，清空掉list
        // @ts-ignore


        if (m.isTop) {
          list = [];
        } // @ts-ignore


        var _children = m[childrenKey] || [];

        if (filter(m)) {
          // 找到了对应的末级了，退出递归
          // @ts-ignore
          list.push(m);
          isFind = true;
          break;
        } else if (_children && _children.length > 0) {
          // 还有子集，继续递归
          list.push(m);
          loop(_children);
        } else {// 没有子集了，也没有找到对应的末级，继续循环
        }
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  };

  loop(array);
  return list;
};
/**
 * 获取树结构中符合filter的item
 * @param datasource
 * @param filter
 * @param childKey
 */


exports.$getItemTree = $getItemTree;

var loopDataTree = function loopDataTree(datasource, filter) {
  var childKey = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'children';
  var result = [];

  for (var i = 0; i < datasource.length; i++) {
    var _item = datasource[i]; // @ts-ignore

    var _children = _item[childKey] || [];

    if (filter(_item)) {
      result.push(_item);
      break;
    } else if (_children.length > 0) {
      result = result.concat(loopDataTree(_children, filter, childKey));
    }
  }

  return result;
};

exports.loopDataTree = loopDataTree;